// AnimatePage.cpp : implementation file
//

#include "stdafx.h"
#include "Control.h"
#include "AnimatePage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAnimatePage property page

IMPLEMENT_DYNCREATE(CAnimatePage, CPropertyPage)

CAnimatePage::CAnimatePage() : CPropertyPage(CAnimatePage::IDD)
{
	//{{AFX_DATA_INIT(CAnimatePage)
	bCenter = FALSE;
	bTransparent = FALSE;
	bAutoplay = FALSE;
	sFileName = _T("");
	//}}AFX_DATA_INIT
	dwStyle = WS_CHILD | WS_VISIBLE | WS_BORDER | ACS_CENTER;
}

CAnimatePage::~CAnimatePage()
{
}

void CAnimatePage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAnimatePage)
	DDX_Check(pDX, IDC_CENTER, bCenter);
	DDX_Check(pDX, IDC_TRANSPARENT, bTransparent);
	DDX_Check(pDX, IDC_AUTOPLAY, bAutoplay);
	DDX_Text(pDX, IDC_EDIT, sFileName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAnimatePage, CPropertyPage)
	//{{AFX_MSG_MAP(CAnimatePage)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDC_CENTER, OnCenter)
	ON_BN_CLICKED(IDC_TRANSPARENT, OnTransparent)
	ON_BN_CLICKED(IDC_AUTOPLAY, OnAutoplay)
	ON_BN_CLICKED(IDC_PLAY, OnPlay)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_EN_KILLFOCUS(IDC_EDIT, OnKillfocusFileNamet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAnimatePage message handlers

void CAnimatePage::OnBrowse() 
{
	CFileDialog dlg (TRUE, "AVI", "*.AVI", OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
								"Animation (*.AVI)|*.AVI|");
	if (dlg.DoModal()!=IDOK) return;
	sFileName = dlg.GetPathName();	//   -  
	UpdateData (FALSE);				//     IDC_EDIT
	ApplyChanges();
}

void CAnimatePage::OnCenter() 
{
	UpdateData();
	if (bCenter)	dwStyle |=  ACS_CENTER;
	else			dwStyle &= ~ACS_CENTER;
	ApplyChanges();
}

void CAnimatePage::OnTransparent() 
{
	UpdateData();
	if (bTransparent)	dwStyle |=  ACS_TRANSPARENT;
	else				dwStyle &= ~ACS_TRANSPARENT;
	ApplyChanges();
}

void CAnimatePage::OnAutoplay() 
{
	UpdateData();
	if (bAutoplay)		dwStyle |=  ACS_AUTOPLAY;
	else				dwStyle &= ~ACS_AUTOPLAY;
	ApplyChanges();
}

void CAnimatePage::OnPlay() 
{			//        (0xFFFF,  -1) 
			//    (1)
	cAnimation.Play (0,0xFFFF,1);
}

void CAnimatePage::OnStop() 
{
	cAnimation.Stop();
}

void CAnimatePage::OnKillfocusFileNamet() 
{
	UpdateData();			//     sFileName
	CFileStatus status;
							//   
	if (CFile::GetStatus(sFileName, status))
		ApplyChanges();
}

BOOL CAnimatePage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	CWnd* pFrame = GetDlgItem (IDC_ANIMFRAME);
	pFrame->GetClientRect (&cArea);
	cAnimation.Create (dwStyle, cArea, pFrame, IDC_ANIMATE);
	return TRUE;
}

void CAnimatePage::ApplyChanges()
{
	cAnimation.Stop();		//   
	cAnimation.Close();
							//   
	::SetWindowLong (cAnimation.GetSafeHwnd(),	GWL_STYLE, dwStyle);
		//  SetWindowPos      
	cAnimation.SetWindowPos (NULL, 0, 0, cArea.Width(),
				cArea.Height(), SWP_NOZORDER | SWP_NOMOVE |
								SWP_NOACTIVATE | SWP_SHOWWINDOW);
							//  AVI-    
	cAnimation.Open (sFileName);
							//      
	InvalidateRect (&cArea);
	UpdateWindow();			//   WM_PAINT    
}
