// MyPage.cpp : implementation file
//

#include "stdafx.h"
#include "Control.h"
#include "MyPage.h"
#include "Graph2D.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyPage property page

IMPLEMENT_DYNCREATE(CMyPage, CPropertyPage)

CMyPage::CMyPage() : CPropertyPage(CMyPage::IDD),
	BlackPen(PS_SOLID,1,RGB(0,0,0)),		//   
	BluePen (PS_SOLID,2,RGB(0,0,255))
{
	rSens[0] = CRect(11,16,16,44);			// 
	rSens[1] = CRect(16,11,44,16);			// 
	rSens[2] = CRect(44,16,49,44);			// 
	rSens[3] = CRect(16,44,44,49);
	pSel = rSens;							//    
	pNow = 0;								//  
	pErs = 0;								//  
	uNow = 4;								//   
	brSel.CreateSolidBrush(RGB(0,0,255));	//  
	brNow.CreateSolidBrush(RGB(0,255,0));
	brErs.CreateSolidBrush(RGB(255,255,255));
	bField = false;							//     
	Axis = X;								//  
											//    
	sBFile[0]="grf4.dat";		sBFile[1]="grf2.dat";
	sBFile[2]="grf3.dat";		sBFile[3]="grf1.dat";
											//     Switcher
	rSwitch = CRect(10,10,50,50);
	//{{AFX_DATA_INIT(CMyPage)
	//}}AFX_DATA_INIT
}

CMyPage::~CMyPage()
{
}

void CMyPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyPage)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMyPage, CPropertyPage)
	//{{AFX_MSG_MAP(CMyPage)
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_CBN_SELENDOK(IDC_B, OnSelendokB)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyPage message handlers

BOOL CMyPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	Bmp.LoadBitmap(IDB_CROSS);
	((CComboBox*)GetDlgItem(IDC_B))->SetCurSel(0);
	return TRUE;
}

void CMyPage::ShowField()
{
					//   ,    
	ifstream is (sBFile[uSide],ios::in | ios::nocreate);
	if (!is)
	{				//  
		CString s =" :" + sBFile[uSide]
						+ " ";
		MessageBox (s,"  ",MB_OK |
							MB_ICONEXCLAMATION);
		return;
	}
	double x,y, Bx,By,Bz;		//  
	UINT size;					//   
	is >> size;					//   
	xPoints.RemoveAll();		//  
	yPoints.RemoveAll();
	xPoints.SetSize(size);
	yPoints.SetSize(size);
					//         
	for (UINT i=0; is && i<size; i++)
	{
		is >> x >> Bx >> By >> Bz;
		y = Axis==X ? Bx : Axis==Y ? By : Bz;
		xPoints.SetAt(i,x);
		yPoints.SetAt(i,y);
	}
	is.close();					//  
	UINT nPoints=i;				//   
	char ax[3][3]={"Bx","By","Bz"};
								//   
	Title = CString(ax[Axis]) + " Field";
	if (nPoints>0)				//   ,  
		bField=true;			//   
	Invalidate();				//    
}

void CMyPage::OnPaint() 
{
	CPaintDC dc(this);					//  
	dc.Rectangle(rSwitch);				//  
	CDC dcMem;							//   
	dcMem.CreateCompatibleDC (&dc);		//  
	dcMem.SelectObject (&Bmp);			//  bitmap-
										//      
	dc.BitBlt(16,16,28,28,&dcMem,0,0,SRCCOPY);
	dcMem.DeleteDC();					//  

	if (pNow)							//    ,
		dc.FillRect(*pNow, &brNow);		//    
	if (pErs)
	{									//  ,  ,
		dc.FillRect(*pErs, &brErs);		//   
		pErs = 0;						//  
	}
	dc.FillRect(*pSel, &brSel);			//   - 
							//    ,   
	if (bField)
	{
		UINT size = xPoints.GetSize();
		CRect r;
		GetClientRect(r);				//    
		CGraph graph(r, size);			//    CGraph
							//      
		CPen* pOldPen = dc.SelectObject (&BlackPen);
		CString Xlab("t"), Ylab("y");
							//     
		graph.DrawGrid (&dc,Title,Xlab,Ylab, xPoints, yPoints);
		BlackPen.Detach();
							//       
		dc.SelectObject (&BluePen);
		graph.DrawFunc (&dc);
		dc.SelectObject (pOldPen);	//  
	}
}

void CMyPage::OnMouseMove(UINT nFlags, CPoint point) 
{
		//       ,   
	for (UINT i=0; i<4 && !rSens[i].PtInRect(point); i++)
		;
	bool bOver = i<4;				//  :    
	uNow = bOver ? i : 4;			//  

	//                
	if (bOver && pNow != &rSens[uNow] && &rSens[uNow] != pSel)
	{				//  ,      
		pNow = &rSens[uNow];
		InvalidateRect(rSwitch);	//  
	}				//   ,   
	else if (!bOver && pNow)
	{				//     
		if (pNow != pSel)			//     ,
			pErs = pNow;			//     
		pNow = 0;					//   
		InvalidateRect(rSwitch);	//   
	}
	CPropertyPage::OnMouseMove(nFlags, point);
}

void CMyPage::OnLButtonDown(UINT nFlags, CPoint point) 
{
			//  ,     
	for (UINT i=0; i<4 && !rSens[i].PtInRect(point); i++)
		;
	if (i<4)
	{						//    ,
		pNow = 0;			//    ,
		pSel = rSens+i;		//     ,
		uSide=i;			//   
		ShowField();		//    
	}
	CPropertyPage::OnLButtonDown(nFlags, point);
}

void CMyPage::OnSelendokB() 
{		//         
	Axis = TAxis(((CComboBox*)GetDlgItem(IDC_B))->GetCurSel());
	ShowField();			//    
}
