// ProgressPage.cpp : implementation file
//

#include "stdafx.h"
#include "Control.h"
#include "ProgressPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CProgressPage property page

IMPLEMENT_DYNCREATE(CProgressPage, CPropertyPage)

CProgressPage::CProgressPage() : CPropertyPage(CProgressPage::IDD)
{
	//{{AFX_DATA_INIT(CProgressPage)
	iDelta = 5;
	uStep = 10;
	uPos = 0;
	uRangeTo = 100;
	uRangeFrom = 0;
	//}}AFX_DATA_INIT
	sPos.Format("%d",uPos);
}

CProgressPage::~CProgressPage()
{
}

void CProgressPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProgressPage)
	DDX_Control(pDX, IDC_PROGRESS, cProgress);
	DDX_Text(pDX, IDC_DELTA, iDelta);
	DDX_Text(pDX, IDC_STEP, uStep);
	DDX_Text(pDX, IDC_POS, uPos);
	DDX_Text(pDX, IDC_TO, uRangeTo);
	DDX_Text(pDX, IDC_FROM, uRangeFrom);
	DDX_Text(pDX, IDC_SHOW, sPos);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CProgressPage, CPropertyPage)
	//{{AFX_MSG_MAP(CProgressPage)
	ON_BN_CLICKED(IDC_STEPIT, OnStepit)
	ON_BN_CLICKED(IDC_SETPOS, OnSetpos)
	ON_BN_CLICKED(IDC_SETDELTA, OnSetdelta)
	ON_BN_CLICKED(IDC_GO, OnGo)
	ON_EN_KILLFOCUS(IDC_FROM, OnKillfocusRange)
	ON_EN_KILLFOCUS(IDC_TO, OnKillfocusRange)
	ON_EN_KILLFOCUS(IDC_STEP, OnKillfocusStep)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProgressPage message handlers

void CProgressPage::OnStepit()
{
	cProgress.StepIt();			//     
	UpdateReading();
}

void CProgressPage::OnSetpos()
{
	UpdateData();
	cProgress.SetPos(uPos);	//     
	UpdateReading();
}

void CProgressPage::OnSetdelta()
{
	UpdateData();
	cProgress.OffsetPos(iDelta);	//     iDelta
	UpdateReading();
}

void CProgressPage::OnKillfocusRange()
{
	UpdateData();
									//   
	cProgress.SetRange(uRangeFrom, uRangeTo);
}

void CProgressPage::OnKillfocusStep()
{
	UpdateData();
	cProgress.SetStep (uStep);		//    
}

void CProgressPage::OnGo()
{		//   
	int nLower, nUpper;				//  
	cProgress.GetRange(nLower, nUpper);
	for (int pos=nLower; pos<=nUpper; pos+=uStep)
	{
		cProgress.SetPos(pos);		//   
		UpdateReading();
		for (int i=0; i < 30000000; i++)
			; 						//   
	}
	cProgress.SetPos(0);
	UpdateReading();
}

BOOL CProgressPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	cProgress.SetRange(uRangeFrom, uRangeTo);	
	return TRUE;
}

void CProgressPage::UpdateReading()
{
	uPos = cProgress.GetPos();		//   
	sPos.Format("%d",uPos);			//   
	UpdateData(FALSE);				//   
}
