// SliderPage.cpp : implementation file
//

#include "stdafx.h"
#include "Control.h"
#include "SliderPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSliderPage property page

IMPLEMENT_DYNCREATE(CSliderPage, CPropertyPage)

CSliderPage::CSliderPage() : CPropertyPage(CSliderPage::IDD)
{
	//{{AFX_DATA_INIT(CSliderPage)
	//}}AFX_DATA_INIT
	uLineStep = 10;			//     
	uPageStep = 50;			//     
	uRangeFrom = 0;			//     
	uRangeTo = 300;			//   
	uSelRangeFrom = 80;		//    
	uSelRangeTo = 220;		//    
	uTickFreq = 20;			//  ( ) 
				//      SetRange
	bAutoticks = TRUE;
				//    
	bEnableSel = TRUE;
				//   (  TBS_HORZ  TBS_VERT)
	iOrientation = 0;
				//  (Combo Box)    
	iTickPos = 0;
	bNoThumb = FALSE;
	bNoTicks = FALSE;
	iPos = 0;
	sMsg = _T("");
}

CSliderPage::~CSliderPage()
{
}

void CSliderPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSliderPage)
	DDX_Text(pDX, IDC_LINE, uLineStep);
	DDX_Text(pDX, IDC_PAGE, uPageStep);
	DDX_Text(pDX, IDC_RANGEFROM, uRangeFrom);
	DDX_Text(pDX, IDC_RANGETO, uRangeTo);
	DDX_Text(pDX, IDC_SELRANGEFROM, uSelRangeFrom);
	DDX_Text(pDX, IDC_SELRANGETO, uSelRangeTo);
	DDX_Text(pDX, IDC_TICKFREQ, uTickFreq);
	DDX_Check(pDX, IDC_ENABLESEL, bEnableSel);
	DDX_Check(pDX, IDC_AUTOTICKS, bAutoticks);
	DDX_Check(pDX, IDC_NOTHUMB, bNoThumb);
	DDX_Check(pDX, IDC_NOTICKS, bNoTicks);
	DDX_CBIndex(pDX, IDC_ORIENTATION, iOrientation);
	DDX_CBIndex(pDX, IDC_TICKPOS, iTickPos);
	DDX_Text(pDX, IDC_SHOW, iPos);
	DDX_Text(pDX, IDC_MSG, sMsg);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSliderPage, CPropertyPage)
	//{{AFX_MSG_MAP(CSliderPage)
	ON_BN_CLICKED(IDC_AUTOTICKS, OnAutoticks)
	ON_BN_CLICKED(IDC_ENABLESEL, OnEnablesel)
	ON_BN_CLICKED(IDC_NOTHUMB, OnNothumb)
	ON_BN_CLICKED(IDC_NOTICKS, OnNoticks)
	ON_EN_KILLFOCUS(IDC_LINE, OnKillfocusLine)
	ON_EN_KILLFOCUS(IDC_PAGE, OnKillfocusPage)
	ON_EN_KILLFOCUS(IDC_RANGEFROM, OnKillfocusRangefrom)
	ON_EN_KILLFOCUS(IDC_RANGETO, OnKillfocusRangeto)
	ON_EN_KILLFOCUS(IDC_SELRANGEFROM, OnKillfocusSelrangefrom)
	ON_EN_KILLFOCUS(IDC_SELRANGETO, OnKillfocusSelrangeto)
	ON_EN_KILLFOCUS(IDC_TICKFREQ, OnKillfocusTickfreq)
	ON_CBN_SELCHANGE(IDC_ORIENTATION, OnSelchangeOrientation)
	ON_CBN_SELCHANGE(IDC_TICKPOS, OnSelchangeTickpos)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER, OnReleased)
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSliderPage message handlers

void CSliderPage::OnAutoticks() 
{
	UpdateData();
				//   (  =1)
	ChangeStyle (TBS_AUTOTICKS, bAutoticks);
				//      
	GetDlgItem (IDC_TICKFREQ)->EnableWindow (bAutoticks);
				//   ==1,     
	if (bAutoticks)
				//    TBM_SETTICFREQ
		cSlider.SetTicFreq (uTickFreq);
	else
		cSlider.ClearTics (TRUE);		//  
}

void CSliderPage::OnNoticks()
{
	UpdateData();
	ChangeStyle (TBS_NOTICKS, bNoTicks);	//  
}

void CSliderPage::OnKillfocusTickfreq()
{
	UpdateData();
	if (bAutoticks)
		cSlider.SetTicFreq (uTickFreq);	//  
}

void CSliderPage::OnEnablesel()
{
	UpdateData();
											//   
	ChangeStyle (TBS_ENABLESELRANGE, bEnableSel);
		//     
		//    
	GetDlgItem (IDC_SELRANGEFROM)->EnableWindow(bEnableSel);
	GetDlgItem (IDC_SELRANGETO)->EnableWindow(bEnableSel);
	if (bEnableSel)			//   
		cSlider.SetSelection (uSelRangeFrom, uSelRangeTo);
	else
		cSlider.ClearSel (TRUE);	//  
	UpdateReading();			//   
}

void CSliderPage::OnNothumb()
{
	UpdateData();			//     
	ChangeStyle (TBS_NOTHUMB, bNoThumb);
}

void CSliderPage::OnKillfocusLine()
{
	UpdateData();			//    
	cSlider.SetLineSize (uLineStep);
}

void CSliderPage::OnKillfocusPage()
{
	UpdateData();
		//       PgUp,PgDn)
	cSlider.SetPageSize (uPageStep);
}

void CSliderPage::OnKillfocusRangefrom()
{
	UpdateData();			//   
	cSlider.SetRangeMin (uRangeFrom, TRUE);
}

void CSliderPage::OnKillfocusRangeto()
{
	UpdateData();			//   
	cSlider.SetRangeMax (uRangeTo, TRUE);
}

void CSliderPage::OnKillfocusSelrangefrom()
{
	UpdateData();			//   ( )
	cSlider.ClearSel();
	cSlider.SetSelection (uSelRangeFrom, uSelRangeTo);
}

void CSliderPage::OnKillfocusSelrangeto()
{
	UpdateData();			//   ( )
	cSlider.ClearSel();
	cSlider.SetSelection (uSelRangeFrom, uSelRangeTo);
}

void CSliderPage::OnSelchangeTickpos()
{
								//   
	UpdateData();
	switch (iTickPos )
	{							//      Combo Box
	case 0:
		ChangeStyle (TBS_BOTH);
		break;
	case 1:
		ChangeStyle (TBS_TOP);			//  ,   TBS_LEFT
		ChangeStyle (TBS_BOTH, FALSE);
		ChangeStyle (TBS_BOTTOM, FALSE);
		break;
	case 2:								//  ,   TBS_RIGHT
		ChangeStyle (TBS_BOTTOM);
		ChangeStyle (TBS_BOTH, FALSE);
		ChangeStyle (TBS_TOP, FALSE);
		break;
	default: break;
	}
}

void CSliderPage::OnSelchangeOrientation() 
{
	UpdateData();
						//      
	CWnd* pWnd = GetDlgItem((0==iOrientation) ?	IDC_HORZPOS : IDC_VERTPOS);
	CRect r;	pWnd->GetWindowRect (&r);
						//      
	ScreenToClient (&r);
						//    
	ChangeStyle (TBS_HORZ, (0 == iOrientation));
						//    
	ChangeStyle (TBS_VERT, (1 == iOrientation));
						//  
	cSlider.SetWindowPos (NULL, r.left,	r.top, r.Width(),
					r.Height(), SWP_NOZORDER | SWP_SHOWWINDOW);
	Invalidate();		//  
}

BOOL CSliderPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
				//   - 
	CWnd* pWnd = GetDlgItem (IDC_HORZPOS);
				//    
	CRect r;		pWnd->GetWindowRect(&r);
	ScreenToClient (&r);				//  
	cSlider.Create(WS_VISIBLE | WS_CHILD | TBS_HORZ | TBS_TOP
							| TBS_AUTOTICKS, r, this, IDC_SLIDER);
				//   TBM_SETTICFREQ
	cSlider.SetTicFreq (uTickFreq);
				//   TBM_SETLINESIZE
	cSlider.SetLineSize (uLineStep);
				//   TBM_SETPAGESIZE
	cSlider.SetPageSize (uPageStep);
				//   
	cSlider.SetRange (uRangeFrom, uRangeTo, TRUE);
				//     
	ChangeStyle (TBS_ENABLESELRANGE, bEnableSel);
	OnEnablesel();
	return TRUE;
}

void CSliderPage::ChangeStyle(long newStyle, BOOL bSet)
{
	long Style;
	Style = GetWindowLong (cSlider.GetSafeHwnd(), GWL_STYLE);
	if (bSet)	
		Style |= newStyle;
	else
		Style &= ~newStyle;
	SetWindowLong (cSlider.GetSafeHwnd(), GWL_STYLE, Style);
	cSlider.SetWindowPos(NULL, 0, 0, 0, 0, SWP_DRAWFRAME |
						SWP_NOSIZE | SWP_NOMOVE | SWP_NOZORDER);
}

void CSliderPage::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	UpdateReading();	
	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CSliderPage::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	UpdateReading();	
	CPropertyPage::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CSliderPage::UpdateReading()
{
	iPos = cSlider.GetPos();			//   
	int iMin, iMax;						//   
	cSlider.GetSelection(iMin, iMax);
	sMsg = "";							//  
	if (bEnableSel)						//    
		if (iPos<iMin || iMax<iPos)		//     ,
										//      IDC_MSG
			sMsg = "Out of Selection Range";
	UpdateData(FALSE);		//     
}

void CSliderPage::OnReleased(NMHDR* pNMHDR, LRESULT* pResult)
{
	//UpdateReading();
	*pResult = 0;
}
