// SpinnerPage.cpp : implementation file
//

#include "stdafx.h"
#include "control.h"
#include "SpinnerPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSpinnerPage property page

IMPLEMENT_DYNCREATE(CSpinnerPage, CPropertyPage)

CSpinnerPage::CSpinnerPage() : CPropertyPage(CSpinnerPage::IDD)
{
	//{{AFX_DATA_INIT(CSpinnerPage)
	uRangeFrom = 0;		//     -
	uRangeTo = 100;		//     -
	iAlignment = 0;		//    -
	iOrientation = 0;	//    -
				//       -
	bSetBuddyInt = FALSE;
				//   - ( Z-)
	bAutoBuddy = FALSE;
				//      3- 
	bNoThousands = FALSE;
	bArrowKeys = FALSE;	//  
	bWrap = FALSE;		//  
	//}}AFX_DATA_INIT
}

CSpinnerPage::~CSpinnerPage()
{
}

void CSpinnerPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSpinnerPage)
	DDX_CBIndex(pDX, IDC_ALIGNMENT, iAlignment);
	DDX_CBIndex(pDX, IDC_SPIN_ORIENTATION, iOrientation);
	DDX_Text(pDX, IDC_SPIN_FROM, uRangeFrom);
	DDX_Text(pDX, IDC_SPIN_TO, uRangeTo);
	DDX_Check(pDX, IDC_ARROWKEYS, bArrowKeys);
	DDX_Check(pDX, IDC_AUTOBUDDY, bAutoBuddy);
	DDX_Check(pDX, IDC_NOTHOUSANDS, bNoThousands);
	DDX_Check(pDX, IDC_SETBUDDYINT, bSetBuddyInt);
	DDX_Check(pDX, IDC_WRAP, bWrap);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSpinnerPage, CPropertyPage)
	//{{AFX_MSG_MAP(CSpinnerPage)
	ON_BN_CLICKED(IDC_ARROWKEYS, OnAnyChange)
	ON_BN_CLICKED(IDC_AUTOBUDDY, OnAnyChange)
	ON_BN_CLICKED(IDC_NOTHOUSANDS, OnAnyChange)
	ON_BN_CLICKED(IDC_SETBUDDYINT, OnAnyChange)
	ON_BN_CLICKED(IDC_WRAP, OnAnyChange)
	ON_CBN_SELCHANGE(IDC_ALIGNMENT, OnAnyChange)
	ON_CBN_SELCHANGE(IDC_SPIN_ORIENTATION, OnAnyChange)
	ON_EN_CHANGE(IDC_SPIN_EDIT, OnAnyChange)
	ON_EN_CHANGE(IDC_SPIN_FROM, OnAnyChange)
	ON_EN_CHANGE(IDC_SPIN_TO, OnAnyChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSpinnerPage message handlers

void CSpinnerPage::OnAnyChange() 
{
	SetModified(TRUE);
}

BOOL CSpinnerPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	CWnd* pEdit = GetDlgItem (IDC_SPIN_EDIT);	// -
	pEdit->GetWindowRect (&rBuddy);
	ScreenToClient (&rBuddy);			//  -
	ModifySpin();						//    
	SetModified(TRUE);					//   Apply
	return TRUE;	
}

void CSpinnerPage::ModifySpin()
{
	DWORD dwStyles=0;					//   
	if (1 == iAlignment)
						//    - 
		dwStyles |= UDS_ALIGNLEFT;
	else if (2 == iAlignment)
		dwStyles |= UDS_ALIGNRIGHT;		//  
	if (bArrowKeys)
		dwStyles |= UDS_ARROWKEYS;		//   *, *
	if (bAutoBuddy)
						//   Z-   
		dwStyles |= UDS_AUTOBUDDY;
	if (bNoThousands)
						//     
		dwStyles |= UDS_NOTHOUSANDS;
	if (1 == iOrientation)
						//   
		dwStyles |= UDS_HORZ;
	if (bSetBuddyInt)
		//       -  
		dwStyles |= UDS_SETBUDDYINT;
	if (bWrap)
						//     
		dwStyles |= UDS_WRAP;
						//   -
	CWnd* p = GetDlgItem (IDC_SPIN_EDIT);
						//   Z-
	p->SetWindowPos (&wndBottom, rBuddy.left, rBuddy.top,
				rBuddy.Width(), rBuddy.Height(), SWP_SHOWWINDOW);

	CWnd* pWnd = GetDlgItem (IDC_SPIN_POS);
	CRect r;						//   -  
	pWnd->GetWindowRect(&r);		//   
	ScreenToClient (&r);
									//  
	cSpin.Create (WS_VISIBLE|WS_CHILD | dwStyles,r, this, IDC_SPIN);
						//   (UDM_SETRANGE)
	cSpin.SetRange (uRangeFrom, uRangeTo);
	TCHAR buf[32];					//    -
						//    (UDM_GETPOS)
	int pos = cSpin.GetPos();
	wsprintf (buf, _T("%d"), pos);	//   
						//   ? (UDM_GETBUDDY)
	pWnd = cSpin.GetBuddy();
	if (pWnd != NULL)				//  ,     
		pWnd->SetWindowText (buf);
}

BOOL CSpinnerPage::OnApply()
{
	UpdateData();			//   
	cSpin.DestroyWindow();	//    
	ModifySpin();			//  
	return CPropertyPage::OnApply();
}
